"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _brembo = _interopRequireDefault(require("brembo"));
var _Connector2 = _interopRequireDefault(require("./Connector"));
var _advancedStatsParser = _interopRequireDefault(require("../util/advancedStatsParser"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var RpkiClientConnector = exports["default"] = /*#__PURE__*/function (_Connector) {
  function RpkiClientConnector(options) {
    var _this$options$host;
    var _this;
    _classCallCheck(this, RpkiClientConnector);
    _this = _callSuper(this, RpkiClientConnector, [options]);
    _defineProperty(_this, "getAdvancedStats", function () {
      if (!_this.setAdvancedStatsTimer) {
        _this.setAdvancedStatsTimer = setInterval(_this._setAdvancedStats, _this.advancedStatsRefreshRateMinutes * 60 * 1000);
        _this._advancedStatsPromise = _this._setAdvancedStats();
      }
      if (_this.index) {
        return Promise.resolve(_this.index);
      } else {
        return _this._advancedStatsPromise.then(function () {
          return _this.index;
        });
      }
    });
    _defineProperty(_this, "_setAdvancedStats", function () {
      var url = _brembo["default"].build(_this.host, {
        path: ["dump.json"],
        params: {
          client: _this.clientId
        }
      });
      var headers = {};
      if (_this.dumpModified) {
        headers["If-Modified-Since"] = _this.dumpModified.toUTCString();
      }
      return _this.axios({
        method: "get",
        url: url,
        maxContentLength: Infinity,
        maxBodyLength: Infinity
      }).then(function (data) {
        if (data && data.data) {
          if (_this.options.verbose) {
            console.log("Loading new roa data");
          }
          _this.dumpModified = new Date(data.headers["last-modified"]);
          _this.index = new _advancedStatsParser["default"]();
          var items = data.data.split('\n');
          var _iterator = _createForOfIteratorHelper(items),
            _step;
          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var item = _step.value;
              try {
                var trimmedItem = item.trim();
                if (trimmedItem.length > 1) {
                  _this.index.add(JSON.parse(trimmedItem));
                }
              } catch (e) {}
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }
        }
      });
    });
    _defineProperty(_this, "_applyRpkiClientMetadata", function () {
      var metadata = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _this.metadata = {
        buildmachine: metadata === null || metadata === void 0 ? void 0 : metadata.buildmachine,
        buildtime: metadata !== null && metadata !== void 0 && metadata.buildtime ? new Date(metadata === null || metadata === void 0 ? void 0 : metadata.buildtime).toISOString() : null,
        // used for if-modified-since
        elapsedtime: metadata === null || metadata === void 0 ? void 0 : metadata.elapsedtime
      };
    });
    _defineProperty(_this, "getVRPs", function () {
      var _this$metadata;
      var url = _brembo["default"].build(_this.host, {
        path: ["vrps.json"],
        params: {
          client: _this.clientId
        }
      });
      var headers = {};
      if ((_this$metadata = _this.metadata) !== null && _this$metadata !== void 0 && _this$metadata.lastModified) {
        headers["If-Modified-Since"] = new Date(_this.metadata.lastModified).toUTCString();
      }
      return _this.axios({
        method: "get",
        url: url,
        headers: headers,
        responseType: "json"
      }).then(function (data) {
        if (data && data.data && data.data.roas) {
          var _data$data;
          var roas = data.data.roas;
          var metadata = (_data$data = data.data) === null || _data$data === void 0 ? void 0 : _data$data.metadata;
          var _headers = data.headers;
          _this._applyRpkiClientMetadata(metadata);
          _this.metadata.lastModified = _headers["last-modified"] ? new Date(_headers["last-modified"]).toISOString() : null;
          return roas.map(function (roa) {
            return {
              prefix: roa.prefix,
              maxLength: roa.maxLength,
              asn: parseInt(roa.asn.toString().replace('AS', '')),
              ta: roa.ta,
              expires: roa.expires || null
            };
          });
        }
      })["catch"](function (error) {
        var _error$response;
        if (((_error$response = error.response) === null || _error$response === void 0 ? void 0 : _error$response.status) !== 304) {
          return Promise.reject(error);
        }
        return null;
      });
    });
    _defineProperty(_this, "getExpiringElements", function (vrp, expires, now) {
      return _this.getAdvancedStats().then(function (index) {
        return index.getExpiring(vrp, expires, now);
      });
    });
    _this.index = null;
    _this.host = (_this$options$host = _this.options.host) !== null && _this$options$host !== void 0 ? _this$options$host : "https://console.rpki-client.org";
    _this.dumpModified = null;
    _this.minimumRefreshRateMinutes = 5;
    _this.advancedStatsRefreshRateMinutes = Math.max(10, _this.options.advancedStatsRefreshRateMinutes);
    return _this;
  }
  _inherits(RpkiClientConnector, _Connector);
  return _createClass(RpkiClientConnector);
}(_Connector2["default"]);